# Autogenerated wrapper script for PYTHIA_jll for x86_64-linux-gnu-cxx03
export libpythia8

## Global variables
PATH = ""
LIBPATH = ""
LIBPATH_env = "LD_LIBRARY_PATH"

# Relative path to `libpythia8`
const libpythia8_splitpath = ["lib", "libpythia8.so"]

# This will be filled out by __init__() for all products, as it must be done at runtime
libpythia8_path = ""

# libpythia8-specific global declaration
# This will be filled out by __init__()
libpythia8_handle = C_NULL

# This must be `const` so that we can use it with `ccall()`
const libpythia8 = "libpythia8.so"


"""
Open all libraries
"""
function __init__()
    global artifact_dir = abspath(artifact"PYTHIA")

    # Initialize PATH and LIBPATH environment variable listings
    global PATH_list, LIBPATH_list
    # We first need to add to LIBPATH_list the libraries provided by Julia
    append!(LIBPATH_list, [joinpath(Sys.BINDIR, Base.LIBDIR, "julia"), joinpath(Sys.BINDIR, Base.LIBDIR)])
    global libpythia8_path = normpath(joinpath(artifact_dir, libpythia8_splitpath...))

    # Manually `dlopen()` this right now so that future invocations
    # of `ccall` with its `SONAME` will find this path immediately.
    global libpythia8_handle = dlopen(libpythia8_path)
    push!(LIBPATH_list, dirname(libpythia8_path))

    # Filter out duplicate and empty entries in our PATH and LIBPATH entries
    filter!(!isempty, unique!(PATH_list))
    filter!(!isempty, unique!(LIBPATH_list))
    global PATH = join(PATH_list, ':')
    global LIBPATH = join(LIBPATH_list, ':')

    # Add each element of LIBPATH to our DL_LOAD_PATH (necessary on platforms
    # that don't honor our "already opened" trick)
    #for lp in LIBPATH_list
    #    push!(DL_LOAD_PATH, lp)
    #end
end  # __init__()

